aboutsummaryrefslogtreecommitdiff
path: root/lib/keyringer/actions/encrypt
diff options
context:
space:
mode:
authorSilvio Rhatto <rhatto@riseup.net>2013-10-18 17:03:40 -0300
committerSilvio Rhatto <rhatto@riseup.net>2013-10-18 17:03:40 -0300
commit72f6db37961e30117818c1d030a7c69869928028 (patch)
tree713c32a61aaf3961cf842f113e8ecd711e10f555 /lib/keyringer/actions/encrypt
parentd402c7b9acd03c9bf8cb4ac9fc4581839cc540b0 (diff)
downloadkeyringer-72f6db37961e30117818c1d030a7c69869928028.tar.gz
keyringer-72f6db37961e30117818c1d030a7c69869928028.tar.bz2
FHS compliance (closes #18)
Diffstat (limited to 'lib/keyringer/actions/encrypt')
-rwxr-xr-xlib/keyringer/actions/encrypt56
1 files changed, 56 insertions, 0 deletions
diff --git a/lib/keyringer/actions/encrypt b/lib/keyringer/actions/encrypt
new file mode 100755
index 0000000..cc73b55
--- /dev/null
+++ b/lib/keyringer/actions/encrypt
@@ -0,0 +1,56 @@
+#!/bin/bash
+#
+# Encrypt files to multiple recipients.
+#
+
+# Load functions
+LIB="`dirname $0`/../functions"
+source "$LIB" || exit 1
+
+# Aditional parameters
+if [ ! -z "$3" ]; then
+ UNENCRYPTED_FILE="$2"
+ shift 2
+ keyringer_get_new_file "$*"
+
+ if [ ! -f "$UNENCRYPTED_FILE" ]; then
+ echo "Error: cannot encrypted $UNENCRYPTED_FILE: file not found."
+ exit 1
+ fi
+else
+ UNENCRYPTED_FILE="-"
+ shift
+ keyringer_get_new_file $*
+fi
+
+# Set recipients file
+keyringer_set_recipients "$FILE"
+
+# Encrypt
+mkdir -p "$KEYDIR/`dirname $FILE`"
+
+if [ "$BASENAME" == "encrypt" ]; then
+ # Only display directions if we're running encrypt, not encrypt-batch
+ if [ "$UNENCRYPTED_FILE" == "-" ]; then
+ echo "Type your message and finish your input with EOF (Ctrl-D)."
+ fi
+fi
+
+$GPG --use-agent --armor -e -s $(keyringer_recipients "$RECIPIENTS_FILE") --yes --output "$KEYDIR/$FILE" $UNENCRYPTED_FILE
+
+err="$?"
+
+if [ "$err" != "0" ]; then
+ exit "$err"
+fi
+
+if [ "$UNENCRYPTED_FILE" != "-" ]; then
+ echo "Now make to wipe the non-encrypted $UNENCRYPTED_FILE."
+fi
+
+# Stage
+if [ -d "$BASEDIR/.git" ]; then
+ keyringer_exec git "$BASEDIR" add "keys/$FILE"
+fi
+
+exit "$?"